// Copyright (c) 2025 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "../../../../dusk/overworld/overworlddefs.h"
#include "../fragments/packed.glsl"
#include "../fragments/quad.glsl"

layout(std140) uniform b_Map {
  uvec4 mapTileIds[OVERWORLD_TILE_COUNT_MAX / PACKED_U8_PER_UVEC4];
  uint mapSize;
  uvec3 _padding0;
};

vec2 mapTileGetSize() {
  return vec2(float(OVERWORLD_TILE_WIDTH), float(OVERWORLD_TILE_HEIGHT));
}

vec2 mapGetVertice(uint instanceIndex, uint indiceIndex) {
  vec2 quad = quadGetVertice(indiceIndex);

  uint mapWidth = packedGetU8(0u, mapSize);
  uint mapHeight = packedGetU8(1u, mapSize);

  quad += vec2(
    float(instanceIndex % mapWidth),
    float(instanceIndex / mapWidth)
  );

  quad *= mapTileGetSize();

  return quad;
}